#include<SPI.h>
#include "misakiUTF16.h"

#define PIN_SPICS 10

int clk = 13;
int din = 11;

//LED DISP DATA RAM
unsigned char dispA[4][8] = {
  {0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0},
};

void setup() 
{
	pinMode(PIN_SPICS, OUTPUT);
	pinMode(clk, OUTPUT);
	pinMode(din, OUTPUT);
	
	SPI.begin();
	SPI.setBitOrder(MSBFIRST);
	SPI.setDataMode(0);
	
	Init_MAX7219();
}

void loop() {
	
	displayUTF16("あいうえ");
	displayUTF16("次は　　");
	displayUTF16("大宮駅　");
	displayUTF16("次は　　");
	displayUTF16("新宿駅　");
	displayUTF16("次は　　");
	displayUTF16("渋谷駅　");
	displayUTF16("次は　　");
	displayUTF16("五反田駅");
	displayUTF16("1234");
	displayUTF16("１２３４");
	displayUTF16("Ｍ９８７");
	displayUTF16("やあさん");
	displayUTF16("→★彡Ω");
}

void displayUTF16(char * pUTF8)
{
	int n=0;
	byte buf[32][8];  //160x8ドットのバナー表示パターン

  while(*pUTF8)
    pUTF8 = getFontData(&buf[n++][0], pUTF8);  // フォントデータの取得
    
	// バッファに反映
	for (int k=0; k < 4; k++) 
	{
		for (int i = 0; i < 8; i++)
		{
			dispA[k][i] = buf[k][i];
		}
	}
	
	disp_view();  //LED0 to LED3 view

}

void disp_view()
{
  for (int i = 1; i < 9; i++) {
    digitalWrite(PIN_SPICS, 0);
    Write_Max7219(i, (dispA)[0][i - 1]);
    Write_Max7219(i, (dispA)[1][i - 1]);
    Write_Max7219(i, (dispA)[2][i - 1]);
    Write_Max7219(i, (dispA)[3][i - 1]);
    digitalWrite(PIN_SPICS, 1);
  }
  digitalWrite(PIN_SPICS, 0);
  delay(1000);
}

void Write_Max7219(char address, char dat)
{
  SPI.transfer(address);
  SPI.transfer(dat);
}

void Init_MAX7219(void)
{
	Write_Max7219int(0x09, 0x00);
	Write_Max7219int(0x0a, 0x04);
	Write_Max7219int(0x0b, 0x07);
	Write_Max7219int(0x0c, 0x01);
	Write_Max7219int(0x0f, 0x00);
	Write_Max7219int(0x00, 0x00);//shift data
	Write_Max7219int(0x00, 0x00);//shift data
	Write_Max7219int(0x00, 0x00);//shift data
	delay(100);
}

void Write_Max7219int(char address, char dat)
{
	digitalWrite(PIN_SPICS, 0);
	SPI.transfer(address);
	SPI.transfer(dat);
	digitalWrite(PIN_SPICS, 1);
}

